/*  example1.ls

    "Перевернутый маятник"

         Этот  пример  представляет  задачу  моделирования  системы
    управления перевернутым маятником.

         Ось маятника  закреплена   на   тележке,   которая   может
    перемещаться в горизонтальном направлении. Тележка приводится в
    движение мотором,  который прикладывает к  тележке cилу  Mi(t),
    являющуюся входной переменной системы. Перемещение оси маятника
    характеризуется функцией   S(t),  угловое  отклонение  маятника
    -  функцией   Fi(t)   (в  градусах),    m  -  масса   маятника,
    L - расстояние от оси до центра тяжести маятника,  Y  -  момент
    инерции   маятника  относительно  центра  тяжести,  М  -  масса
    тележки, Н и V - силы реакции оси маятника.

         Для системы справедливы следующие уравнения:

             2
            d
         m────[ s(t) + L sin Fi(t) ] = H(t),
            2
          dt

             2
            d
         m────[ L cos Fi(t) ] = V(t) - mg,
            2
          dt

           2
          d Fi(t)
         J───── = L V(t) cos Fi(t) - L H(t) cos Fi(t),
            2
          dt

           2
          d s(t)                   ds(t)
         M───── =  Mi(t) - H(t) - F─────,
             2                      dt
           dt

         Обозначив
                    2
              J + mL
         L1= ─────── ,
               mL
         m1 =  Mi,
         X1(t) = s(t),
         X2(t) = s'(t),
         X3(t) = Fi (t),
         X4(t) = Fi '(t),
    приведем систему уравнений к форме Коши:

         X1' = X2;

                1        F
         X2' = ─── m1 - ─── X2;
                M        M

         X3' = X4;

                 g              F                 1
         X4' = ────  sin X3 - ───── X2 cos X3 - ───── cos X3 m1.
                L1             M L1              M L1

         Последняя форма записи  практически  без  изменений  может
    быть принята в качестве программы для системы LSX.
*/

// МОДЕЛЬ ОБЪЕКТА;

  X1' = X2;
  X2' = -(F/M)*X2 + (1/M)*MЮ;
  X3' = X4;
  X4' = (G/L1)*math.sin(X3) + F*X2*math.cos(X3) / (M*L1) - math.cos(X3)*МЮ / (M*L1);

// МОДЕЛЬ ИЗМЕРЕНИЙ ;

  Z1 = X1;  Z2 = X2;  Z3 = X3; Z4 = X4;

// МОДЕЛЬ РЕГУЛЯТОРА;

  МЮ = -( K1*Z1 + K2*Z2 + K3*Z3 + K4*Z4 );

